import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A Human that does not accept the Pair.
 * 
 * @author (Cameron Olson) 
 * @version (0.01)
 */
public class Intolerant extends Human
{
    int key;
    boolean female;
    /**
     * constructor for Intolerant.
     */
    public Intolerant(int key)
    {
        this.key = key;
        if(Greenfoot.getRandomNumber(2) == 1)
        {
            setImage("female3.png");
            female = true;
        }
        else
        {
            setImage("male3.png");
            female = false;
        }   
    }

    /**
     * Be Intolerant.
     */
    public void act() 
    {
        setBounds();
        moveToPlayer();
    }    

    /**
     * move towards the player
     */
    public void moveToPlayer()
    {
        if( !((Level)(getWorld())).isHetero(key) && ((Level)(getWorld())).getPaired())
        {
            Level w = (Level)getWorld();
            if(w.key == 11)
            {
                return;
            }
            if(female)
            {
                setImage("female4.png");
            }
            else
            {
                setImage("male4.png");
            }
            if(w.player == null || w.pair == null) //super sketch
            {
                return;
            }
            if(!w.paired)
            {
                if(getX() > w.player.getX())
                {
                    setLocation(getX() - 1, getY());
                }
                else if(getX() < w.player.getX())
                {
                    setLocation(getX() + 1, getY());
                }
                if(getY() > w.player.getY())
                {
                    setLocation(getX(), getY() -1);
                }
                else if(getY() < w.player.getY())
                {
                    setLocation(getX(), getY()+1);
                }
            }
            else
            {
                if(getX() > w.pair.getX())
                {
                    setLocation(getX() - 1, getY());
                }
                else if(getX() < w.pair.getX())
                {
                    setLocation(getX() + 1, getY());
                }
                if(getY() > w.pair.getY())
                {
                    setLocation(getX(), getY() -1);
                }
                else if(getY() < w.pair.getY())
                {
                    setLocation(getX(), getY()+1);
                }
            }
        }
    }
}
