import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A Human that dislikes the player.
 * 
 * @author (Cameron Olson) 
 * @version (0.01)
 */
public class Jerk extends Human
{
    /**
     * Constructor for Jerks
     */
    public Jerk(int key) 
    {
        if(Greenfoot.getRandomNumber(2) == 1)
        {
            setImage("female4.png");
        }
        else
        {
            setImage("male4.png");
        }
    }

    /**
     * Be a Jerk.
     */
    public void act() 
    {
        setBounds();
        moveToPlayer();
    }

    /**
     * move towards the player
     */
    public void moveToPlayer()
    {
        //Human pl = ((Level)(getWorld())).getPlayer();
        Level w = (Level)getWorld();
        //System.out.println(w);
        if(w.player == null || w.pair == null) //super sketch
        {
            return;
        }
        if(!w.paired)
        {
            if(getX() > w.player.getX())
            {
                setLocation(getX() - 1, getY());
            }
            else if(getX() < w.player.getX())
            {
                setLocation(getX() + 1, getY());
            }
            if(getY() > w.player.getY())
            {
                setLocation(getX(), getY() -1);
            }
            else if(getY() < w.player.getY())
            {
                setLocation(getX(), getY()+1);
            }
        }
        else
        {
            if(getX() > w.pair.getX())
            {
                setLocation(getX() - 1, getY());
            }
            else if(getX() < w.pair.getX())
            {
                setLocation(getX() + 1, getY());
            }
            if(getY() > w.pair.getY())
            {
                setLocation(getX(), getY() -1);
            }
            else if(getY() < w.pair.getY())
            {
                setLocation(getX(), getY()+1);
            }
        }
    }
}
