import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Level2 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Level11 extends Level
{

    Lover lover;
    Ring ring;
    
    boolean grabbed;
    
    Bystander gm1;
    Intolerant i1, i2, i3, i4, i5, i6, i7, i8;
    /**
     * Constructor for objects of class Level3.
     */
    public Level11()
    {            // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super();
        key = 11;
        grabbed = false;
        
        player = new Player(key);
        addObject(player, 40, 300);
        player.setBounds();
        lover = new Lover(key);
        addObject(lover, 280, 440);
        lover.setBounds();
        ring = new Ring();
        addObject(ring, 700, 100);
        ring.setBounds();
        pair = new Pair(key);
        
        i1 = new Intolerant(key);
        addObject(i1, 400, 40);
        i2 = new Intolerant(key);
        addObject(i2, 400, 120);
        i3 = new Intolerant(key);
        addObject(i3, 400, 200);
        i4 = new Intolerant(key);
        addObject(i4, 400, 280);
        i5 = new Intolerant(key);
        addObject(i5, 400, 360);
        i6 = new Intolerant(key);
        addObject(i6, 400, 440);
        i7 = new Intolerant(key);
        addObject(i7, 400, 520);
        i8 = new Intolerant(key);
        addObject(i8, 400, 600);
        
        gm1 = new Bystander(key, 0);
        addObject(gm1, 700, 600);
        gm1.setBounds();
    }
    
    
    public void act()
    {
        checkPair();
        checkRing();
        playSound(player, lover);
        checkLose();
        takeRing();
    }
    
    /**
     * checks to see if the pair has formed. Creates Pair.
     */
    public void checkPair()
    {
        if(!paired && collideHuman(player, lover))
        {
            paired = true;
            addObject(pair, lover.getX(), lover.getY());
            removeObject(player);
            removeObject(lover);
        }
    }
    
    /**
     * checks to see if the pair has collided with the ring. (AKA the level is finished)
     */
    public void checkRing()
    {
        if(paired && collideRing(pair, ring))
        {
            Greenfoot.setWorld(new Level11());
        }
    }
    
    /**
     * checks to see if the player has collided with a Jerk or Intolerant.
     */
    public void checkLose()
    {
        if(paired)
        {
            if(jerkCollide(pair, key) && grabbed)
            {
                Greenfoot.setWorld(new Level12());
            }
            else if(jerkCollide(pair, key))
            {
                Greenfoot.setWorld(new Level11());
            }
        }
        else if(jerkCollide(player, key))
        {
            if(grabbed)
            {
                Greenfoot.setWorld(new Level12());
            }
            else if(!grabbed)
            {
                Greenfoot.setWorld(new Level11());
            }
        }
    }
    
    public void takeRing()
    {
        if(grabbed)
        {
            return;
        }
        if(collideRing(gm1, ring) || gm1.getY() == ring.getY())
        {
            removeObject(gm1);
            removeObject(ring);
            grabbed = true;
        }
    }
    
}

