import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Level2 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Level4 extends Level
{

    Lover lover;
    Ring ring;
    
    Bystander gm1, gm2, gm3, bg1, bg2, bg3;
    /**
     * Constructor for objects of class Level3.
     * 
     */
    public Level4()
    {            // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super();
        key = 4;
        
        player = new Player(key);
        addObject(player, 430, 500);
        player.setBounds();
        lover = new Lover(key);
        addObject(lover, 380, 240);
        lover.setBounds();
        ring = new Ring();
        addObject(ring, 400, 60);
        pair = new Pair(key);
        
        gm1 = new Bystander(key, 0);
        addObject(gm1, 150, 200);
        gm2 = new Bystander(key, 0);
        addObject(gm2, 200, 200);
        gm3 = new Bystander(key, 0);
        addObject(gm3, 250, 200);
        
        bg1 = new Bystander(key, 1);
        addObject(bg1, 550, 200);
        bg2 = new Bystander(key, 1);
        addObject(bg2, 600, 200);
        bg3 = new Bystander(key, 1);
        addObject(bg3, 650, 200);
    
    }
    
    
    public void act()
    {
        checkPair();
        checkRing();
        playSound(player, lover);
        checkLose();
    }
    
    /**
     * checks to see if the pair has formed. Creates Pair.
     */
    public void checkPair()
    {
        if(!paired && collideHuman(player, lover))
        {
            paired = true;
            addObject(pair, lover.getX(), lover.getY());
            removeObject(player);
            removeObject(lover);
        }
    }
    
    /**
     * checks to see if the pair has collided with the ring. (AKA the level is finished)
     */
    public void checkRing()
    {
        if(paired && collideRing(pair, ring))
        {
            Greenfoot.setWorld(new Level5());
        }
    }
    
    /**
     * checks to see if the player has collided with a Jerk or Intolerant.
     */
    public void checkLose()
    {
        if(paired)
        {
            if(jerkCollide(pair, key))
            {
                Greenfoot.setWorld(new Level4());
            }
        }
        else if(jerkCollide(player, key))
        {
            Greenfoot.setWorld(new Level4());
        }
    }
    
}
