import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Level2 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Level6 extends Level
{

    Lover lover;
    Ring ring;
    
    Bystander b1;
    /**
     * Constructor for objects of class Level3.
     * 
     */
    public Level6()
    {            // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super();
        key = 6;
        
        player = new Player(key);
        addObject(player, 400, 300);
        player.setBounds();
        lover = new Lover(key);
        addObject(lover, 20, 500);
        lover.setBounds();
        ring = new Ring();
        addObject(ring, 400, 100);
        pair = new Pair(key);
        
        b1 = new Bystander(key, 1);
        addObject(b1, 700, 500);    
    }
    
    
    public void act()
    {
        checkPair();
        checkRing();
        playSound(player, lover);
        checkLose();
    }
    
    /**
     * checks to see if the pair has formed. Creates Pair.
     */
    public void checkPair()
    {
        if(!paired && collideHuman(player, lover))
        {
            paired = true;
            addObject(pair, lover.getX(), lover.getY());
            removeObject(player);
            removeObject(lover);
        }
    }
    
    /**
     * checks to see if the pair has collided with the ring. (AKA the level is finished)
     */
    public void checkRing()
    {
        if(paired && collideRing(pair, ring))
        {
            Greenfoot.setWorld(new Level7());
        }
    }
    
    /**
     * checks to see if the player has collided with a Jerk or Intolerant.
     */
    public void checkLose()
    {
        if(paired)
        {
            if(jerkCollide(pair, key))
            {
                Greenfoot.setWorld(new Level6());
            }
        }
        else if(jerkCollide(player, key))
        {
            Greenfoot.setWorld(new Level6());
        }
    }
    
}

