import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Level2 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Level8 extends Level
{

    Lover lover;
    Ring ring;
    
    Bystander gm1, gm2, gm3, bg1, bg2, bg3;
    Intolerant i1, i2, i3;
    /**
     * Constructor for objects of class Level3.
     * 
     */
    public Level8()
    {            // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super();
        key = 8;
        
        player = new Player(key);
        addObject(player, 40, 300);
        player.setBounds();
        lover = new Lover(key);
        addObject(lover, 680, 440);
        lover.setBounds();
        ring = new Ring();
        addObject(ring, 100, 200);
        pair = new Pair(key);
        
        i3 = new Intolerant(key);
        addObject(i3, 100, 550);
        i3 = new Intolerant(key);
        addObject(i3, 300, 500);
        i3 = new Intolerant(key);
        addObject(i3, 600, 100);
    }
    
    
    public void act()
    {
        checkPair();
        checkRing();
        playSound(player, lover);
        checkLose();
    }
    
    /**
     * checks to see if the pair has formed. Creates Pair.
     */
    public void checkPair()
    {
        if(!paired && collideHuman(player, lover))
        {
            paired = true;
            addObject(pair, lover.getX(), lover.getY());
            removeObject(player);
            removeObject(lover);
        }
    }
    
    /**
     * checks to see if the pair has collided with the ring. (AKA the level is finished)
     */
    public void checkRing()
    {
        if(paired && collideRing(pair, ring))
        {
            Greenfoot.setWorld(new Level9());
        }
    }
    
    /**
     * checks to see if the player has collided with a Jerk or Intolerant.
     */
    public void checkLose()
    {
        if(paired)
        {
            if(jerkCollide(pair, key))
            {
                Greenfoot.setWorld(new Level8());
            }
        }
        else if(jerkCollide(player, key))
        {
            Greenfoot.setWorld(new Level8());
        }
    }
    
}