import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Level2 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Level9 extends Level
{

    Lover lover;
    Ring ring;
    
    Bystander gm1, gm2, gm3, bg1, bg2, bg3;
    Jerk j1, j2, j3;
    /**
     * Constructor for objects of class Level3.
     * 
     */
    public Level9()
    {            // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super();
        key = 9;
        
        player = new Player(key);
        addObject(player, 140, 300);
        player.setBounds();
        lover = new Lover(key);
        addObject(lover, 200, 300);
        lover.setBounds();
        ring = new Ring();
        addObject(ring, 700, 500);
        pair = new Pair(key);
        
        j1 = new Jerk(key);
        addObject(j1, 50, 50);
        j2 = new Jerk(key);
        addObject(j2, 50, 200);
        j3 = new Jerk(key);
        addObject(j3, 50, 400);
    }
    
    
    public void act()
    {
        checkPair();
        checkRing();
        playSound(player, lover);
        checkLose();
    }
    
    /**
     * checks to see if the pair has formed. Creates Pair.
     */
    public void checkPair()
    {
        if(!paired && collideHuman(player, lover))
        {
            paired = true;
            addObject(pair, lover.getX(), lover.getY());
            removeObject(player);
            removeObject(lover);
        }
    }
    
    /**
     * checks to see if the pair has collided with the ring. (AKA the level is finished)
     */
    public void checkRing()
    {
        if(paired && collideRing(pair, ring))
        {
            Greenfoot.setWorld(new Level10());
        }
    }
    
    /**
     * checks to see if the player has collided with a Jerk or Intolerant.
     */
    public void checkLose()
    {
        if(paired)
        {
            if(jerkCollide(pair, key))
            {
                Greenfoot.setWorld(new Level9());
            }
        }
        else if(jerkCollide(player, key))
        {
            Greenfoot.setWorld(new Level9());
        }
    }
    
}